package DB_HASH;
use strict;
use DB_File;
use Fcntl;
use Data::Dumper;

use vars qw($VAR1);

sub new {
   my $proto = shift;
   my $class = ref($proto) || $proto;
   my $self = {
       file    => shift,
       DBM     => {},
   };
   bless ($self,$class);
   return $self;
}

sub openr {
    my $self = shift;
    tie (%{$self->{DBM}}, 'DB_File', $self->{file}, O_RDONLY, 0666, $DB_HASH) || die $!;
}

sub closer {
    my $self = shift;
    untie %{$self->{DBM}};
}

sub openw {
    my $self = shift;
    my $append = shift;
    tie (%{$self->{DBM}}, 'DB_File', $self->{file}, O_RDWR|O_CREAT, 0666) || die $!;
}

sub closew {
    my $self = shift;
    untie %{$self->{DBM}};
}

sub exists {
    my $self = shift;
    my $entry = shift;
    return 1 if (exists ($self->{DBM}{$entry}));
    return 0;
}

sub get_files {
    my $self = shift;
    my @keys = keys %{$self->{DBM}};
    return @keys;
}

sub get_entry {
    my $self = shift;
    my $entry = shift;
    return eval($self->{DBM}{$entry});
}

sub write {
    my $self = shift;
    my $entry = shift;
    my $arrayref = shift;
    my $data = Dumper($arrayref);
    $self->{DBM}{$entry} = $data;
}
1;


